{============================================================================}
{==                                                                        ==}
{==                 SUPER CORECTOR DATAFILE CODER Version 3.0              ==}
{==                   Copyright (C) 1994-96 By The GodFather               ==}
{==                                                                        ==}
{============================================================================}

{$M, 8192, 0, 655355}

USES Crt,
     GUtils, GMemory;

TYPE
  PFindReplace = ^TFindReplace;
  TFindReplace = OBJECT(TObject)
    Find       : PString;
    Replace    : PString;
    CONSTRUCTOR Init(NEW_Find,NEW_Replace:STRING);
    DESTRUCTOR Done; VIRTUAL;
  END;

  PFindReplaceCollection = ^TFindReplaceCollection;
  TFindReplaceCollection = OBJECT( TCollection )
  END;

  PCrack = ^TCrack;
  TCrack = OBJECT(TObject)
    C_Name  : PString;
    F_Name  : PString;
    FR_Data : PFindReplaceCollection;
    CONSTRUCTOR Init(NEW_C_Name, NEW_F_Name: STRING;
                     NEW_FindReplace       : PFindReplaceCollection );
    DESTRUCTOR Done; VIRTUAL;
  END;

  PCrackCollection = ^TCrackCollection;
  TCrackCollection = OBJECT( TCollection )
  END;

  PGame = ^TGame;
  TGame = OBJECT( TObject )
    Name : PString;
    Data : PCrackCollection;
    CONSTRUCTOR Init( NEW_Name: STRING; NEW_Data: PCrackCollection );
    DESTRUCTOR Done; VIRTUAL;
  END;

  PGamesCollection = ^TGamesCollection;
  TGamesCollection = OBJECT( TSortedCollection )
    FUNCTION KeyOf( Item: Pointer ): Pointer; VIRTUAL;
    FUNCTION Compare( Key1, Key2: Pointer ): Integer; VIRTUAL;
  END;

VAR
  Database: PGamesCollection;

{--------------------------------------------------------}
CONSTRUCTOR TFindReplace.Init(NEW_Find, NEW_Replace: STRING );
BEGIN
  Find    := NewStr(NEW_Find);
  Replace := NewStr(NEW_Replace);
END;

DESTRUCTOR TFindReplace.Done;
BEGIN
  DisposeStr(Find);
  DisposeStr(Replace);
END;

CONSTRUCTOR TCrack.Init(NEW_C_Name, NEW_F_Name: STRING;
                        NEW_FindReplace       : PFindReplaceCollection );
BEGIN
  C_Name  := NewStr(NEW_C_Name);
  F_Name  := NewStr(NEW_F_Name);
  FR_Data := NEW_FindReplace;
END;

DESTRUCTOR TCrack.Done;
BEGIN
  DisposeStr(C_Name);
  DisposeStr(F_Name);
  Dispose(FR_Data,Done);
END;
{--------------------------------------------------------}

{--------------------------------------------------------}
CONSTRUCTOR TGame.Init( NEW_Name: STRING; NEW_Data: PCrackCollection );
BEGIN
  Name := NewStr(NEW_Name);
  Data := NEW_Data;
END;

DESTRUCTOR TGame.Done;
BEGIN
  DisposeStr(Name);
  Dispose(Data, Done);
END;

FUNCTION TGamesCollection.KeyOf(Item: Pointer): Pointer;
BEGIN
  KeyOf := @PGame(Item)^.Name;
END;

FUNCTION TGamesCollection.Compare(Key1, Key2: Pointer): Integer;
BEGIN
  IF PString( Key1^ )^ = PString( Key2^ )^
    THEN Compare := 0
    ELSE IF PString( Key1^ )^ < PString( Key2^ )^
      THEN Compare := -1
      ELSE Compare := 1;
END;
{--------------------------------------------------------}

PROCEDURE GetCracks;
VAR
  DataFile: Text;
  C_Data  : PCrackCollection;
  _GName  : STRING;
  Cnt     : Word;

  PROCEDURE GetCrk; NEAR;
  VAR TmpDTA: PCrackCollection;
      Tmp_FR: PFindReplaceCollection;
      _CName, _FName, _Find, _Replace: STRING;

     PROCEDURE ReadFR;
     VAR FR_DTA: PFindReplaceCollection;
     BEGIN
       New(FR_DTA,Init(1,1));
       REPEAT
         Readln(DataFile, _Find);
         Readln(DataFile, _Replace);
         FR_DTA^.Insert(New(PFindReplace, Init(_Find,_Replace)));
       UNTIL _Find[Length(_Find)] <> '+';
       Tmp_FR := FR_DTA;
     END;

  BEGIN
    New(TmpDTA,Init(1,1));
    REPEAT
      Readln(DataFile, _CName); IF _CName = '-END-' THEN Break;
      Readln(DataFile, _FName);
      ReadFR;
      TmpDTA^.Insert(New(PCrack, Init(_CName,_FName,Tmp_FR)));
    UNTIL Eof(DataFile);
    C_Data := TmpDTA;
  END;

BEGIN
  Assign(DataFile, 'GSUPER.###');
  {$I-}
    Reset(DataFile);
  {$I+}
  IF IOResult <> 0 THEN
  BEGIN
    Writeln('Can''t open GSUPER.###');
    Halt(2);
  END;
  Cnt := 1;
  Write('Reading ');
  Database := New(PGamesCollection, Init(1, 1));
  Database^.Duplicates := True;
  REPEAT
    Inc(Cnt);
    IF Cnt = 13 THEN BEGIN Write('.'); Cnt := 1; END;
    Readln(DataFile, _GName);
    GetCrk;
    Database^.Insert(New( PGame, Init(_GName,C_Data)));
  UNTIL Eof(DataFile);
  Close(DataFile);
  Writeln;
END;

PROCEDURE CodeFile;
VAR
  F        : Text;
  AnEntry  : PGame;
  TheCrack : PCrack;
  TheFRDta : PFindReplace;
  I,R,G,Cnt: Word;
  Enter    : STRING[2];

  FUNCTION SSC(ST: STRING): STRING;
  VAR S1,S2: STRING;

    PROCEDURE Replace(WordNo: Byte; What: STRING; Ch: STRING);
    VAR S2: STRING;
    BEGIN
      IF WordNo = 1 THEN S2 := '' ELSE S2 := ExtractWords(1,1,St);
      IF AdjCase(Upper, ExtractWords(WordNo,1,St)) = AdjCase(Upper, What) THEN
      BEGIN
        St := S2 + Ch + ExtractWords(WordNo+1,WordCnt(St),St);
      END;
    END;

  BEGIN
    St := Copy(St,2,Length(St)-1);
    Replace(1,'Make'     ,'! ');
    Replace(1,'Remove'   ,'@ ');
    Replace(1,'Stop'     ,'# ');
    Replace(1,'Unlimited','$ ');

    Replace(2,'BALLS'    ,'! ');
    Replace(2,'BOMBS'    ,'@ ');
    Replace(2,'BULLETS'  ,'# ');
    Replace(2,'ENERGY'   ,'$ ');
    Replace(2,'LIFE'     ,'% ');
    Replace(2,'LIFES'    ,'^ ');
    Replace(2,'MONEY'    ,'& ');
    Replace(2,'MISSLES'  ,'* ');
    Replace(2,'PASSWORDS','( ');
    Replace(2,'SHIELD'   ,') ');
    Replace(2,'TIME'     ,'_ ');
    Replace(2,'TIMER'    ,'+ ');
    SSC := ST;
  END;

BEGIN
  Assign(F,'GSUPER.DAT');
  Rewrite(F);
  GotoXY(1,WhereY-1);
  TextColor(7);
  Write('Writing ');
  TextColor(14);
  Write(F,'SUPER CORECTOR DATAFILE'#26);
  Write(F,CurrentDate+' '+CurrentTime+'h'#26);
  Enter := #20;
  Cnt := 1;
  FOR R := 0 TO Database^.Count-1 DO
  BEGIN
    Inc(Cnt);
    IF Cnt = 13 THEN BEGIN Write('o'); Cnt := 1; END;
    AnEntry := Database^.At(R);
    Write(F,EncodeStr(AnEntry^.Name^) + Enter);
    FOR I := 0 TO AnEntry^.Data^.Count - 1 DO
    BEGIN
      TheCrack := AnEntry^.Data^.At(I);
      Write(F, EncodeStr(SSC(TheCrack^.C_Name^)) + Enter);
      Write(F, EncodeStr(TheCrack^.F_Name^) + Enter);
      FOR G := 0 TO TheCrack^.FR_Data^.Count - 1 DO
      BEGIN
        TheFRDta := TheCrack^.FR_Data^.At(G);
        Write(F, EncodeStr(StripAll(GetStr(TheFRDta^.Find   ),' ')) + Enter);
        Write(F, EncodeStr(StripAll(GetStr(TheFRDta^.Replace),' ')) + Enter);
      END;
    END;
    Write(F, EncodeStr('<>') + Enter);
  END;
  Close(F);
  Dispose(Database, Done);
  GotoXY(1,WhereY); ClrEol;
  Writeln('GSUPER.DAT is written OK.'); TextAttr := 7;
  Writeln;
END;

BEGIN
  Writeln;
  Writeln('SUPER CORECTOR DATAFILE CODER Version 3.0');
  Writeln('Copyright (C) 1994-96 By The GodFather');
  Writeln;
  GetCracks;
  CodeFile;
END.
